unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ExtCtrls;

type
  TForm1 = class(TForm)
    edtAddr: TEdit;
    btnConnect: TButton;
    edtPort: TEdit;
    CSocket: TClientSocket;
    lblPort: TLabel;
    lblAddr: TLabel;
    lstboxEvents: TListBox;
    lblCmd: TLabel;
    edtCmd: TEdit;
    btnCmd: TButton;
    lblEvents: TLabel;
    tmr: TTimer;
    procedure btnConnectClick(Sender: TObject);
    procedure CSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure CSocketDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure CSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure btnCmdClick(Sender: TObject);
    procedure ServerEvent(ev,prm1,prm2:string);
    procedure ClientSend(pr,prm1,prm2:string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tmrTimer(Sender: TObject);
    procedure edtPortKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  connected:bool;               // jsem pripojen?
  Nlevels:integer;              // pocet pater
  shafts:array of record        // vytahy
                    jsem,jedu:integer;    // kde je, kam jede(ma li nekam jet)
                    free:boolean;         // je volny?
                  end;
  kamkdo:array of array of integer;  // kam ma ktery vytah jet
  tmrdal:array of boolean;

implementation

{$R *.dfm}

procedure TForm1.btnConnectClick(Sender: TObject);
// ovladani tlacitka Pripojit/Odpojit
begin
  if connected then begin      // jsem pripojen => musim se odpojit
    CSocket.Close;
  end else begin               // jsem odpojen => musim se pripojit
    try
      CSocket.Port:=StrToInt(edtPort.Text);    // nastaveni portu
      CSocket.Host:=edtAddr.Text;              // nastaveni adresy
      CSocket.Open;
    except
      MessageDlg('Pipojen se nepovedlo',mtError,[mbOK],0);
    end;
  end;
end;

procedure TForm1.CSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
// pripojeni k serveru
begin
  connected:=true;
  lstboxEvents.Items.Add('ClientOpen');
  btnConnect.Caption:='Odpojit';
  edtCmd.Enabled:=true;
  btnCmd.Enabled:=true;
  edtPort.Enabled:=false;
  edtAddr.Enabled:=false;
  ClientSend('levels','','');
  ClientSend('shafts','','');
  ClientSend('lipinfo','Hi','');
end;

procedure TForm1.CSocketDisconnect(Sender: TObject; Socket: TCustomWinSocket);
// odpojeni od serveru
begin
  connected:=false;
  lstboxEvents.Items.Add('ClientClose');
  btnConnect.Caption:='Pripojit';
  edtCmd.Enabled:=false;
  btnCmd.Enabled:=false;
  edtPort.Enabled:=true;
  edtAddr.Enabled:=true;
end;

procedure TForm1.CSocketRead(Sender: TObject; Socket: TCustomWinSocket);
// nacte udalosti serveru, zjisti parametry a zajisti reakce (ServerEvent)
const mezi=' ';
var
  events,event,ev,prm1,prm2:string;
  p:integer;
begin
  prm1:='';
  prm2:='';
  events:=Socket.ReceiveText;            // nacteni vseho co server posila
  while pos(#13+#10,events)>0 do begin     // pro kazdou udalost (oddelovac=#13+#10)
    event:=copy(events,1,pos(#13+#10,events)-1);
    delete(events,1,length(event)+2);      // nacteni dalsi udalosti,smazani z nevyrizenych
    if (event<>'') and (event[1]=#9) then begin // vypis,zajisteni tabulatoru
      delete(event,1,1);
      lstboxEvents.Items.Add('    '+event);
    end else lstboxEvents.Items.Add(event);
    ev:=copy(event,1,pos(mezi,event)-1);   // jmeno prikazu
    delete(event,1,length(ev));
    if event<>'' then begin
      delete(event,1,1);
      p:=pos(mezi,event);
      if p>0 then prm1:=copy(event,1,p-1)  // parametr 1
             else prm1:=copy(event,1,length(event));
      delete(event,1,length(prm1));
    end;
    if event<>'' then begin                // parametr 2
      delete(event,1,1);
      p:=pos(mezi,event);
      if p>0 then prm2:=copy(event,1,p-1)
             else prm2:=copy(event,1,length(event));
    end;
    ServerEvent(ev,prm1,prm2);             // reakce
  end;
end;

procedure TForm1.btnCmdClick(Sender: TObject);
// posle serveru prikaz z command line
begin
  CSocket.Socket.SendText(edtCmd.text+#13+#10);
  edtCmd.Text:='';
end;

procedure TForm1.ServerEvent(ev,prm1,prm2:string);
// reaguje na udalosti serveru
var i:integer;
begin
  if ev='shafts' then begin             // udalost shafts- nastavi pocet vytahu
    SetLength(shafts,StrToInt(prm1));
    for i:=0 to high(shafts) do begin
      shafts[i].jsem:=0;
      shafts[i].jedu:=0;
      shafts[i].free:=true;
    end;
    SetLength(kamkdo,StrToInt(prm1));
    SetLength(tmrdal,StrToInt(prm1));
    for i:=0 to high(tmrdal) do tmrdal[i]:=false
  end else if ev='levels' then          // udalost levels - nastavi pocet pater
    Nlevels:=StrToInt(prm1)
  else if ev='levelbuttonup' then begin       // stisk tlacitka nahoru
    ClientSend('indiupon',prm1,'');
    for i:=0 to high(shafts) do begin
      if shafts[i].free then begin
        shafts[i].jedu:=StrToInt(prm1);
        ClientSend('shaftinfo',IntToStr(i),'Up'+prm1);
        ClientSend('close',IntToStr(i),'');
        shafts[i].free:=false;
      end;
    end;
  end else if ev='levelbuttondn' then begin   // stisk tlacitka dolu
    ClientSend('indidnon',prm1,'');
    for i:=0 to high(shafts) do begin
      if shafts[i].free then begin
        shafts[i].jedu:=StrToInt(prm1);
        ClientSend('shaftinfo',IntToStr(i),'Dn'+prm1);
        ClientSend('close',IntToStr(i),'');
        shafts[i].free:=false;
      end;
    end;
  end else if ev='cabinbutton' then begin     // stisk tlacitka ve vytaku
    ClientSend('indion',prm1,prm2);
    i:=StrToInt(prm1);
    if shafts[i].free then begin
      shafts[i].jedu:=StrToInt(prm2);
      ClientSend('shaftinfo',IntToStr(i),'Go'+prm2);
      ClientSend('close',prm1,'');
      shafts[i].free:=false;
    end else begin
      SetLength(kamkdo[i],high(kamkdo[i])+2);
      kamkdo[i,high(kamkdo[i])]:=StrToInt(prm2);
    end;
  end else if ev='closed' then begin          // dvere se zavrely
    i:=StrToInt(prm1);
    if shafts[i].jsem<>shafts[i].jedu then begin
      ClientSend('floor',prm1,IntToStr(shafts[i].jedu));
    end;
  end else if ev='opened' then begin          // dvere se otevrely
    i:=StrToInt(prm1);
    ClientSend('indidnoff',IntToStr(shafts[i].jsem),'');
    ClientSend('indiupoff',IntToStr(shafts[i].jsem),'');
    ClientSend('indioff',prm1,IntToStr(shafts[i].jsem));
    if high(kamkdo[i])=-1 then
      shafts[i].free:=true
    else begin
      tmrdal[i]:=true;
      tmr.Enabled:=false;
      tmr.Enabled:=true;
    end;
  end else if ev='level' then begin           // vytah je v nejakem patre
    i:=StrToInt(prm1);
    shafts[i].jsem:=StrToInt(prm2);
    if shafts[i].jsem=shafts[i].jedu then begin
      ClientSend('shaftinfo',prm1,'Ok'+prm2);
      ClientSend('open',prm1,'');
    end;
  end;
end;

procedure TForm1.ClientSend(pr,prm1,prm2:string);
// posle serveru prikaz pr s pripadnymi parametry prm1, prm2
var s:string;
begin
  s:=pr;
  if prm1<>'' then s:=s+' '+prm1;
  if prm2<>'' then s:=s+' '+prm2;
  s:=s+#13+#10;
  CSocket.Socket.SendText(s);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
// kontrola pri ukoncovani aplikace, je-li ukonceno spojeni
begin
  if connected then CSocket.Close;
end;

procedure TForm1.tmrTimer(Sender: TObject);
// jestli ma nejaky vytah jet nekam dal ovlada timer
var i:integer;
begin
  for i:=0 to high(tmrdal) do begin
    if tmrdal[i]=true then begin
      shafts[i].jedu:=kamkdo[i,high(kamkdo[i])];
      SetLength(kamkdo[i],high(kamkdo[i]));
      if high(kamkdo[i])=-1 then tmrdal[i]:=false;
      ClientSend('close',IntToStr(i),'')
    end;
  end
end;

procedure TForm1.edtPortKeyPress(Sender: TObject; var Key: Char);
// do edtPort dovolime psat pouze cisla a pouzivat BackSpace
begin
  if not (key in ['0'..'9',#8]) then
    key:=#0;
end;

end.
